import java.applet.Applet;
import java.awt.*;
import java.awt.image.*;
 
public class Panorama extends Applet implements Runnable
{
	public static final String REVISION_DATE="July 29 2001";
	
	Thread runner;
	MediaTracker tracker;
	String marker="nhgube EWUZ";            //security
    String marker2="ina qra Oretu";         //security
    boolean created;

    Image picture;
    int x,y,xAdd,width,height,delay;
    boolean bounce;

    String loadString="Loading please wait";

    boolean mouseDown=false,mouseDraged=false,mouseIn=false;
    Point mouse=new Point(0,0);
    int stop=1;

    Object frame;

    boolean sizeVertical;
    Image offscreenI;
    Graphics offscreenG;

public void init()
{
    super.init();
    System.out.println(getAppletInfo());
    while (marker!="nhgube EWUZ" || marker2!="ina qra Oretu"){}

    if (getParameter("load_string")!=null) loadString=getParameter("load_string");

    if (getParameter("size_vertical")!=null && getParameter("size_vertical").equalsIgnoreCase("true"))
    {
        sizeVertical=true;
        offscreenI=createImage(size().width,size().height);
        offscreenG=offscreenI.getGraphics();
    }else sizeVertical=false;


    //geting the frame of this applet
  	frame = this;
	while (frame != null && !(frame instanceof Frame)) {
		frame = ((Component) frame).getParent();
	}

    created=false;
}


public void start()
{
    if (runner==null){ runner = new Thread(this);runner.start();}
}

public void stop()
{
	if (runner!=null){runner.stop();runner=null;}
}

private boolean create()
{
    delay=50;String tempS=getParameter("delay");
    if (tempS!=null) delay=Integer.parseInt(tempS);

    xAdd=-1;tempS=getParameter("x_add");
    if (tempS!=null) xAdd=Integer.parseInt(tempS);

    bounce=false;tempS=getParameter("bounce");
    if (tempS!=null) if (tempS.toLowerCase().equals("true")) bounce=true;

    String filename=getParameter("picture");

    if (filename!=null)
    {
        MediaTracker tracker;
        picture=getImage(getCodeBase(),filename);
        tracker=new MediaTracker(this);
        tracker.addImage(picture,0);
        try
        {
            tracker.waitForID(0);
        }catch (InterruptedException e)
        {
            System.out.println("IO error loading images");
        }
        width=picture.getWidth(this);
        height=picture.getHeight(this);
    }

    return true;
}

public void run()
{
    while (Thread.currentThread() == runner)
    {
        repaint();
        pause(delay);
        if (created)
        {
            if (!mouseDown)
            {
                x+=(stop*xAdd);
                if (!bounce && (x<-width || x>=width)) x=0;
                if (bounce && (x>=0 || x+width<=size().width))
                {
                    xAdd*=-1;x+=2*xAdd;
                }
            }
        } else { repaint(200);created=create();}
	}
}

public boolean handleEvent(Event evt)
{
    if (!created) return true;
    switch (evt.id)
    {
        case Event.MOUSE_ENTER:
            ((Frame)frame).setCursor(Frame.CROSSHAIR_CURSOR);
            mouseIn=true;
            return true;
        case Event.MOUSE_EXIT:
            ((Frame)frame).setCursor(Frame.DEFAULT_CURSOR);
            mouseIn=false;
            return true;
        case Event.MOUSE_DOWN:
            mouse.x=evt.x;
            mouse.y=evt.y;
            mouseDown=true;
            mouseDraged=false;
            return true;
        case Event.MOUSE_UP:
            if (evt.x>=size().width || evt.x<0 || evt.y>=size().height || evt.y<0) mouseIn=false;
            if (mouseIn) ((Frame)frame).setCursor(Frame.CROSSHAIR_CURSOR); else ((Frame)frame).setCursor(Frame.DEFAULT_CURSOR);
            mouseDown=false;
            if (mouse.x==evt.x && mouse.y==evt.y && !mouseDraged) stop=0; else stop=1;
            mouseDraged=false;
            return true;
        case Event.MOUSE_DRAG:
            ((Frame)frame).setCursor(Frame.MOVE_CURSOR);
            mouseDraged=true;
            x+=(evt.x-mouse.x);
            if (x<-width) x+=width;
            if (x>=width) x-=width;
            if ((evt.x<mouse.x && xAdd>0) || (evt.x>mouse.x && xAdd<0)) xAdd*=-1;
            mouse.x=evt.x;
            if (!sizeVertical)
            {
                y+=(evt.y-mouse.y);
                if (y+height<=size().height) y=size().height-height;
                if (y>0) y=0;
                mouse.y=evt.y;
            }
            return true;
    }
    return true;
}

public synchronized void update(Graphics g)
{
    if (!created)
    {
        FontMetrics fm=getFontMetrics(g.getFont());
        int x=(int)((size().width-fm.stringWidth(loadString))/2),y=(size().height/2);
        g.drawString(loadString,x,y);
    }
    if (picture!=null)
    {
        if (sizeVertical && picture.getHeight(this)!=size().height)
        {
            if (offscreenI!=null)
            {
                offscreenG.drawImage(picture,x,y,picture.getWidth(this),size().height, this );
                if (x<0) offscreenG.drawImage(picture,x+width,y,picture.getWidth(this),size().height,this);
                if (x>0) offscreenG.drawImage(picture,x-width,y,picture.getWidth(this),size().height,this);
                g.drawImage(offscreenI,0,0,this);
            }
        } else
        {
            g.drawImage(picture,x,y,this);
            if (x<0) g.drawImage(picture,x+width,y,this);
            if (x>0) g.drawImage(picture,x-width,y,this);
        }
    }
}

public void paint(Graphics g)
{
    update(g);
}

public String getAppletInfo()
{
    return " \nPanorama applet \n(c)1998 rvdb@comweb.nl \nhttp://www.comweb.nl/~rvdb\n"+REVISION_DATE;
}

private void pause(int time)
{
    if (time==0) return;//prevent a NullPointerException
    try { Thread.sleep(time); } catch (InterruptedException e) {}
}

}